/**
  * Outils(le terrier d'AbulEdu)
  *
  * @warning aucun traitement d'erreur n'est pour l'instant implémenté
  * @see https://redmine.ryxeo.com/projects/leterrier-aller
  * @author 2011 Jean-Louis Frucot <frucot.jeanlouis@free.fr>
  * @see The GNU Public License (GPL)

 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "abuledutetev1.h"
#include <QLabel>
#include <QPixmap>
#include <QDebug>

AbulEduTeteV1::AbulEduTeteV1(QString prefixeTete, int nbTete, int taille, QWidget *parent) :
    QHBoxLayout(parent)
{
    Q_UNUSED(parent)
    m_taille =QSize(taille, taille);
    m_listeTetes.clear();
    suffixe = new QMap<int, QString>();
    suffixe->insert(0, "Neutre");
    suffixe->insert(1, "Bien");
    suffixe->insert(2, "Passable");
    suffixe->insert(3, "Mal");

    resetTetes(prefixeTete, nbTete, parent);

}

void AbulEduTeteV1::resetTetes(QString prefixeTete, int nbTete, QWidget *parent)
{
    // On efface toutes les têtes
    QLayoutItem *child;
     while ((child = this->takeAt(0)) != 0) {
         child->widget()->deleteLater();
         delete child;
     }
    m_listeTetes.clear();
    m_prefixe = prefixeTete;
    for(int i=0; i<nbTete; i++)
    {
        QLabel *lblTete = new QLabel();
        lblTete->resize(m_taille);
        lblTete->setPixmap(QPixmap(QString(":/"+m_prefixe+"/Neutre")).scaled(m_taille,Qt::KeepAspectRatio, Qt::SmoothTransformation));
        this->addWidget(lblTete);
//        this->addStretch();
        m_listeTetes.append(0);
    }
}

void AbulEduTeteV1::setEtatTete(int numTete, int tete)
{
    if(numTete < this->count() && tete>=0 && tete < 4)
    {
    QLabel *lbl = static_cast< QLabel *>(this->itemAt(numTete)->widget());
    lbl->setPixmap(QPixmap(QString(":/"+m_prefixe+"/"+suffixe->value(tete))).scaled(m_taille, Qt::KeepAspectRatio, Qt::SmoothTransformation));
    m_listeTetes[numTete]=tete;
    }
}

void AbulEduTeteV1::resizeTetes(int taille)
{
    m_taille = QSize(taille, taille);
    for(int i = 0; i < this->count(); i++)
    {
        setEtatTete(i, m_listeTetes[i]);
    }
}

int AbulEduTeteV1::getEtatTete(int numTete)
{
    return m_listeTetes[numTete];
}

QList<int> AbulEduTeteV1::getEtatTetes()
{
    return m_listeTetes;
}
